build.sh 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | grep Xcode)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcbeautify
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. local xcodebuild_args=("$@")
  100. local buildaction="${xcodebuild_args[$# - 1]}" # buildaction is the last arg
  101. local log_filename="xcodebuild-${buildaction}.log"
  102. local xcbeautify_cmd=(xcbeautify --renderer github-actions --disable-logging)
  103. local result=0
  104. NSUnbufferedIO=YES xcodebuild "$@" 2>&1 | tee "$log_filename" | \
  105. "${xcbeautify_cmd[@]}" && CheckUnexpectedFailures "$log_filename" \
  106. || result=$?
  107. if [[ $result == 65 ]]; then
  108. ExportLogs "$@"
  109. echo "xcodebuild exited with 65, retrying" 1>&2
  110. sleep 5
  111. result=0
  112. NSUnbufferedIO=YES xcodebuild "$@" 2>&1 | tee "$log_filename" | \
  113. "${xcbeautify_cmd[@]}" && CheckUnexpectedFailures "$log_filename" \
  114. || result=$?
  115. fi
  116. if [[ $result != 0 ]]; then
  117. echo "xcodebuild exited with $result" 1>&2
  118. ExportLogs "$@"
  119. return $result
  120. fi
  121. }
  122. # Exports any logs output captured in the xcresult
  123. function ExportLogs() {
  124. python "${scripts_dir}/xcresult_logs.py" "$@"
  125. }
  126. function CheckUnexpectedFailures() {
  127. local log_file=$1
  128. if grep -Eq "[1-9]\d* failures \([1-9]\d* unexpected\)" "$log_file"; then
  129. echo "xcodebuild failed with unexpected failures." 1>&2
  130. return 65
  131. fi
  132. }
  133. if [[ "$xcode_major" -lt 16 && "$method" != "cmake" ]]; then
  134. echo "Unsupported Xcode major version being used: $xcode_major"
  135. exit 1
  136. else
  137. iphone_simulator_name="iPhone 16"
  138. if [[ "$xcode_major" -gt 16 ]]; then
  139. iphone_simulator_name="iPhone 16e"
  140. fi
  141. ios_flags=(
  142. -sdk 'iphonesimulator'
  143. -destination "platform=iOS Simulator,name=${iphone_simulator_name}"
  144. )
  145. watchos_flags=(
  146. -sdk 'watchsimulator'
  147. -destination 'platform=watchOS Simulator,name=Apple Watch Series 10 (42mm)'
  148. )
  149. fi
  150. ios_device_flags=(
  151. -sdk 'iphoneos'
  152. -destination 'generic/platform=iOS'
  153. )
  154. ipad_flags=(
  155. -sdk 'iphonesimulator'
  156. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  157. )
  158. macos_flags=(
  159. -sdk 'macosx'
  160. -destination 'platform=OS X,arch=x86_64'
  161. )
  162. tvos_flags=(
  163. -sdk "appletvsimulator"
  164. -destination 'platform=tvOS Simulator,name=Apple TV'
  165. )
  166. visionos_flags=(
  167. # As of Aug 15, 2025, the default OS "latest" was failing as it matched both
  168. # the visionOS 26 beta and visionOS 2.5 (from Xcode 16.4) simulators;
  169. # explicitly specifying OS=2.5 in destination as a workaround.
  170. -sdk 'xrsimulator'
  171. -destination 'platform=visionOS Simulator,OS=2.5,name=Apple Vision Pro'
  172. )
  173. catalyst_flags=(
  174. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  175. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  176. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  177. )
  178. # Compute standard flags for all platforms
  179. case "$platform" in
  180. iOS)
  181. xcb_flags=("${ios_flags[@]}")
  182. gen_platform=ios
  183. ;;
  184. iOS-device)
  185. xcb_flags=("${ios_device_flags[@]}")
  186. gen_platform=ios
  187. ;;
  188. iPad)
  189. xcb_flags=("${ipad_flags[@]}")
  190. ;;
  191. macOS)
  192. xcb_flags=("${macos_flags[@]}")
  193. gen_platform=macos
  194. ;;
  195. tvOS)
  196. xcb_flags=("${tvos_flags[@]}")
  197. gen_platform=tvos
  198. ;;
  199. watchOS)
  200. xcb_flags=("${watchos_flags[@]}")
  201. ;;
  202. visionOS)
  203. xcb_flags=("${visionos_flags[@]}")
  204. ;;
  205. catalyst)
  206. xcb_flags=("${catalyst_flags[@]}")
  207. ;;
  208. all)
  209. xcb_flags=()
  210. ;;
  211. Linux)
  212. xcb_flags=()
  213. ;;
  214. *)
  215. echo "Unknown platform '$platform'" 1>&2
  216. exit 1
  217. ;;
  218. esac
  219. xcb_flags+=(
  220. ONLY_ACTIVE_ARCH=YES
  221. CODE_SIGNING_REQUIRED=NO
  222. CODE_SIGNING_ALLOWED=YES
  223. COMPILER_INDEX_STORE_ENABLE=NO
  224. )
  225. source scripts/buildcache.sh
  226. xcb_flags=("${xcb_flags[@]}" "${buildcache_xcb_flags[@]}")
  227. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  228. # Right now, it makes the log overflow on Travis because many of our
  229. # dependencies don't build cleanly this way.
  230. cmake_options=(
  231. -Wdeprecated
  232. -DCMAKE_BUILD_TYPE=Debug
  233. )
  234. if [[ -n "${SANITIZERS:-}" ]]; then
  235. for sanitizer in $SANITIZERS; do
  236. case "$sanitizer" in
  237. asan)
  238. xcb_flags+=(
  239. -enableAddressSanitizer YES
  240. )
  241. cmake_options+=(
  242. -DWITH_ASAN=ON
  243. )
  244. ;;
  245. tsan)
  246. xcb_flags+=(
  247. -enableThreadSanitizer YES
  248. )
  249. cmake_options+=(
  250. -DWITH_TSAN=ON
  251. )
  252. ;;
  253. ubsan)
  254. xcb_flags+=(
  255. -enableUndefinedBehaviorSanitizer YES
  256. )
  257. cmake_options+=(
  258. -DWITH_UBSAN=ON
  259. )
  260. ;;
  261. *)
  262. echo "Unknown sanitizer '$sanitizer'" 1>&2
  263. exit 1
  264. ;;
  265. esac
  266. done
  267. fi
  268. case "$product-$platform-$method" in
  269. FirebasePod-iOS-*)
  270. RunXcodebuild \
  271. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  272. -scheme "FirebasePodTest" \
  273. "${xcb_flags[@]}" \
  274. build
  275. ;;
  276. Auth-*-*)
  277. if check_secrets; then
  278. RunXcodebuild \
  279. -project 'FirebaseAuth/Tests/SampleSwift/AuthenticationExample.xcodeproj' \
  280. -scheme "$method" \
  281. "${xcb_flags[@]}" \
  282. test
  283. fi
  284. ;;
  285. CombineSwift-*-xcodebuild)
  286. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  287. RunXcodebuild \
  288. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  289. -scheme "FirebaseCombineSwift-Unit-unit" \
  290. "${xcb_flags[@]}" \
  291. build
  292. ;;
  293. # TODO(#14760): s/build/test after addressing UI test flakes on CI.
  294. InAppMessaging-*-xcodebuild)
  295. RunXcodebuild \
  296. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  297. -scheme 'FiamDisplaySwiftExample' \
  298. "${xcb_flags[@]}" \
  299. build
  300. ;;
  301. Firestore-*-xcodebuild)
  302. "${firestore_emulator}" start
  303. trap '"${firestore_emulator}" stop' ERR EXIT
  304. RunXcodebuild \
  305. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  306. -scheme "Firestore_IntegrationTests_$platform" \
  307. -enableCodeCoverage YES \
  308. "${xcb_flags[@]}" \
  309. test
  310. ;;
  311. Firestore-macOS-cmake | Firestore-Linux-cmake)
  312. "${firestore_emulator}" start
  313. trap '"${firestore_emulator}" stop' ERR EXIT
  314. (
  315. test -d build || mkdir build
  316. cd build
  317. echo "Preparing cmake build ..."
  318. cmake -G Ninja "${cmake_options[@]}" ..
  319. echo "Building cmake build ..."
  320. ninja -k 10 all
  321. ctest --verbose
  322. )
  323. ;;
  324. SymbolCollision-*-*)
  325. RunXcodebuild \
  326. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  327. -scheme "SymbolCollisionTest" \
  328. "${xcb_flags[@]}" \
  329. build
  330. ;;
  331. # TODO(#12205) Restore this test to "test" instead of "build"
  332. Messaging-*-xcodebuild)
  333. pod_gen FirebaseMessaging.podspec --platforms=ios
  334. # Add GoogleService-Info.plist to generated Test Wrapper App.
  335. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  336. AppHost-FirebaseMessaging-Unit-Tests \
  337. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  338. if check_secrets; then
  339. # Integration tests are only run on iOS to minimize flake failures.
  340. RunXcodebuild \
  341. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  342. -scheme "FirebaseMessaging-Unit-integration" \
  343. "${ios_flags[@]}" \
  344. "${xcb_flags[@]}" \
  345. build
  346. fi
  347. ;;
  348. MessagingSample-*-*)
  349. if check_secrets; then
  350. RunXcodebuild \
  351. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  352. -scheme "Sample" \
  353. "${xcb_flags[@]}" \
  354. build
  355. fi
  356. ;;
  357. SwiftUISample-*-*)
  358. if check_secrets; then
  359. RunXcodebuild \
  360. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  361. -scheme "SwiftUISample" \
  362. "${xcb_flags[@]}" \
  363. build
  364. fi
  365. ;;
  366. # TODO: This is actually building for iOS instead of watchOS. Update to use
  367. # watchOS xcb_flags along with the watchOS sdk option. Also nanopb and promises
  368. # podspecs need minimum version updates.
  369. MessagingSampleStandaloneWatchApp-*-*)
  370. if check_secrets; then
  371. RunXcodebuild \
  372. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  373. -scheme "SampleStandaloneWatchApp Watch App" \
  374. -destination 'platform=watchOS Simulator,name=Apple Watch Series 10 (42mm)' \
  375. build
  376. fi
  377. ;;
  378. MLModelDownloaderSample-*-*)
  379. if check_secrets; then
  380. RunXcodebuild \
  381. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  382. -scheme "MLDownloaderTestApp" \
  383. "${xcb_flags[@]}" \
  384. build
  385. fi
  386. ;;
  387. WatchOSSample-*-*)
  388. RunXcodebuild \
  389. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  390. -scheme "SampleWatchAppWatchKitApp" \
  391. "${xcb_flags[@]}" \
  392. build
  393. ;;
  394. Database-*-integration)
  395. "${database_emulator}" start
  396. trap '"${database_emulator}" stop' ERR EXIT
  397. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  398. RunXcodebuild \
  399. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  400. -scheme "FirebaseDatabase-Unit-integration" \
  401. "${xcb_flags[@]}" \
  402. build \
  403. test
  404. ;;
  405. RemoteConfig-*-fakeconsole)
  406. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  407. RunXcodebuild \
  408. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  409. -scheme "FirebaseRemoteConfig-Unit-fake-console-tests" \
  410. "${xcb_flags[@]}" \
  411. build \
  412. test
  413. ;;
  414. RemoteConfig-*-integration)
  415. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  416. # Add GoogleService-Info.plist to generated Test Wrapper App.
  417. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  418. AppHost-FirebaseRemoteConfig-Unit-Tests \
  419. ../../../FirebaseRemoteConfig/Tests/Swift/SwiftAPI/GoogleService-Info.plist
  420. # Add AccessToken to generated Test Wrapper App.
  421. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  422. AppHost-FirebaseRemoteConfig-Unit-Tests \
  423. ../../../FirebaseRemoteConfig/Tests/Swift/AccessToken.json
  424. # Integration tests are only run on iOS to minimize flake failures.
  425. RunXcodebuild \
  426. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  427. -scheme "FirebaseRemoteConfig-Unit-swift-api-tests" \
  428. "${xcb_flags[@]}" \
  429. build \
  430. test
  431. ;;
  432. RemoteConfigSample-*-*)
  433. RunXcodebuild \
  434. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  435. -scheme "RemoteConfigSampleApp" \
  436. "${xcb_flags[@]}" \
  437. build
  438. ;;
  439. FirebaseAIIntegration-*-*)
  440. # Build
  441. RunXcodebuild \
  442. -project 'FirebaseAI/Tests/TestApp/FirebaseAITestApp.xcodeproj' \
  443. -scheme "FirebaseAITestApp-SPM" \
  444. "${xcb_flags[@]}" \
  445. build
  446. # Run tests
  447. RunXcodebuild \
  448. -project 'FirebaseAI/Tests/TestApp/FirebaseAITestApp.xcodeproj' \
  449. -scheme "FirebaseAITestApp-SPM" \
  450. "${xcb_flags[@]}" \
  451. -parallel-testing-enabled NO \
  452. -retry-tests-on-failure \
  453. -test-iterations 3 \
  454. test
  455. ;;
  456. Sessions-*-integration)
  457. # Perform "pod install" to install the relevant dependencies
  458. # ./FirebaseSessions/generate_testapp.sh
  459. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  460. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  461. # Run E2E Integration Tests for Prod.
  462. RunXcodebuild \
  463. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  464. -scheme "AppQualityDevApp_iOS" \
  465. "${ios_flags[@]}" \
  466. "${xcb_flags[@]}" \
  467. build \
  468. test
  469. # Run E2E Integration Tests for Staging.
  470. RunXcodebuild \
  471. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  472. -scheme "AppQualityDevApp_iOS" \
  473. FirebaseSessionsRunEnvironment=STAGING \
  474. "${ios_flags[@]}" \
  475. "${xcb_flags[@]}" \
  476. build \
  477. test
  478. # Run E2E Integration Tests for Autopush.
  479. RunXcodebuild \
  480. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  481. -scheme "AppQualityDevApp_iOS" \
  482. FirebaseSessionsRunEnvironment=AUTOPUSH \
  483. "${ios_flags[@]}" \
  484. "${xcb_flags[@]}" \
  485. build \
  486. test
  487. ;;
  488. StorageSwift-*-xcodebuild)
  489. pod_gen FirebaseStorage.podspec --platforms=ios
  490. # Add GoogleService-Info.plist to generated Test Wrapper App.
  491. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  492. AppHost-FirebaseStorage-Unit-Tests \
  493. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  494. if check_secrets; then
  495. # Integration tests are only run on iOS to minimize flake failures.
  496. RunXcodebuild \
  497. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  498. -scheme "FirebaseStorage-Unit-integration" \
  499. "${ios_flags[@]}" \
  500. "${xcb_flags[@]}" \
  501. test
  502. fi
  503. ;;
  504. StorageObjC-*-xcodebuild)
  505. pod_gen FirebaseStorage.podspec --platforms=ios
  506. # Add GoogleService-Info.plist to generated Test Wrapper App.
  507. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  508. AppHost-FirebaseStorage-Unit-Tests \
  509. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  510. if check_secrets; then
  511. # Integration tests are only run on iOS to minimize flake failures.
  512. RunXcodebuild \
  513. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  514. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  515. "${ios_flags[@]}" \
  516. "${xcb_flags[@]}" \
  517. test
  518. fi
  519. ;;
  520. StorageCombine-*-xcodebuild)
  521. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  522. # Add GoogleService-Info.plist to generated Test Wrapper App.
  523. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  524. AppHost-FirebaseCombineSwift-Unit-Tests \
  525. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  526. if check_secrets; then
  527. # Integration tests are only run on iOS to minimize flake failures.
  528. RunXcodebuild \
  529. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  530. -scheme "FirebaseCombineSwift-Unit-integration" \
  531. "${ios_flags[@]}" \
  532. "${xcb_flags[@]}" \
  533. test
  534. fi
  535. ;;
  536. GoogleDataTransport-watchOS-xcodebuild)
  537. RunXcodebuild \
  538. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  539. -scheme "GDTWatchOSTestAppWatchKitApp" \
  540. "${xcb_flags[@]}" \
  541. build
  542. RunXcodebuild \
  543. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  544. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  545. "${xcb_flags[@]}" \
  546. build
  547. RunXcodebuild \
  548. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  549. -scheme "GDTCCTWatchOSCompanionTestApp" \
  550. "${xcb_flags[@]}" \
  551. build
  552. ;;
  553. Performance-*-unit)
  554. # Run unit tests on prod environment with unswizzle capabilities.
  555. export FPR_UNSWIZZLE_AVAILABLE="1"
  556. export FPR_AUTOPUSH_ENV="0"
  557. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  558. RunXcodebuild \
  559. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  560. -scheme "FirebasePerformance-Unit-unit" \
  561. "${xcb_flags[@]}" \
  562. build \
  563. test
  564. ;;
  565. Performance-*-proddev)
  566. # Build the prod dev test app.
  567. export FPR_UNSWIZZLE_AVAILABLE="0"
  568. export FPR_AUTOPUSH_ENV="0"
  569. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  570. RunXcodebuild \
  571. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  572. -scheme "FirebasePerformance-TestApp" \
  573. "${xcb_flags[@]}" \
  574. build
  575. ;;
  576. Performance-*-integration)
  577. # Generate the workspace for the SDK to generate Protobuf files.
  578. export FPR_UNSWIZZLE_AVAILABLE="0"
  579. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  580. # Perform "pod install" to install the relevant dependencies
  581. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  582. # Run E2E Integration Tests for Autopush.
  583. RunXcodebuild \
  584. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  585. -scheme "FIRPerfE2EAutopush" \
  586. FPR_AUTOPUSH_ENV=1 \
  587. "${ios_flags[@]}" \
  588. "${xcb_flags[@]}" \
  589. build \
  590. test
  591. # Run E2E Integration Tests for Prod.
  592. RunXcodebuild \
  593. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  594. -scheme "FIRPerfE2EProd" \
  595. "${ios_flags[@]}" \
  596. "${xcb_flags[@]}" \
  597. build \
  598. test
  599. ;;
  600. FirebaseDataConnect-*-spm)
  601. RunXcodebuild \
  602. -scheme $product \
  603. "${xcb_flags[@]}" \
  604. IPHONEOS_DEPLOYMENT_TARGET=15.0 \
  605. TVOS_DEPLOYMENT_TARGET=15.0 \
  606. test
  607. ;;
  608. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  609. *-*-spm)
  610. RunXcodebuild \
  611. -scheme $product \
  612. "${xcb_flags[@]}" \
  613. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  614. TVOS_DEPLOYMENT_TARGET=13.0 \
  615. test
  616. ;;
  617. *-*-spmbuildonly)
  618. RunXcodebuild \
  619. -scheme $product \
  620. "${xcb_flags[@]}" \
  621. build
  622. ;;
  623. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  624. RunXcodebuild \
  625. -project 'IntegrationTesting/ClientApp/ClientApp.xcodeproj' \
  626. -scheme $product \
  627. "${xcb_flags[@]}" \
  628. build
  629. ;;
  630. ClientApp-CocoaPods*-iOS-xcodebuild)
  631. RunXcodebuild \
  632. -workspace 'IntegrationTesting/ClientApp/ClientApp.xcworkspace' \
  633. -scheme $product \
  634. "${xcb_flags[@]}" \
  635. build
  636. ;;
  637. *)
  638. echo "Don't know how to build this product-platform-method combination" 1>&2
  639. echo " product=$product" 1>&2
  640. echo " platform=$platform" 1>&2
  641. echo " method=$method" 1>&2
  642. exit 1
  643. ;;
  644. esac